use test
go

if OBJECT_ID('dbo.tbl1', N'U') is not null
	drop table dbo.tbl1;
go

if OBJECT_ID('dbo.tbl2', N'U') is not null
	drop table dbo.tbl2;
go

create table dbo.tbl1 (
	id int primary key clustered,
	d char(1) default('a')
);
go

create table dbo.tbl2 (
	id int primary key clustered,
	d char(1) default('a')
);
go

declare @i int = 1
while @i < 100
begin
	insert into dbo.tbl1(id) values(@i)
	insert into dbo.tbl2(id) values(@i)
	set @i += 1
end


if OBJECT_ID('dbo.fn_list', N'TF') is not null
	drop function dbo.fn_list;
go

create function dbo.fn_list(
	@less_than int
)
returns @returntable table 
(
	id int,
	d char(1)
)
as
begin
    insert @returntable
    select id, d
	from dbo.tbl1
	where id < @less_than
    return
end
go

set statistics io on

select *
from dbo.fn_list(50) as f
inner join dbo.tbl2 as t on t.id = f.id

select *
from dbo.tbl1 as t1
inner join dbo.tbl2 as t2 on t2.id = t1.id
where t1.id < 50
